#!/bin/bash

# This file is part of xmlfuzzer.
#
# xmlfuzzer is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# xmlfuzzer is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with xmlfuzzer.  If not, see <http://www.gnu.org/licenses/>.
#
# Copyright 2010 Alexander Markov <apsheronets@gmail.com>
# Center of Innovative Security Solutions
# http://binanalysis.com

root=`pwd`
results=$root/results
orig_base=/home/komar/deb/home/komar/xmlfuzzer/ooxml/base
xsd=/home/komar/deb/home/komar/ooxml/OfficeOpenXML-XMLSchema/wml.xsd
xmlfuzzer=/home/komar/devel/xmlfuzzer
ignore_tags=$xmlfuzzer/ooxml/ignore_tags
ignore_attrs=$xmlfuzzer/ooxml/ignore_attrs
preferred_tags=$xmlfuzzer/ooxml/preferred_tags
i=$1

batch=$results/$i
mkdir -p $batch
$xmlfuzzer/xmlfuzzer.opt \
  -xsd $xsd \
  -root-elem document \
  -ignore-tags $ignore_tags \
  -ignore-attrs $ignore_attrs \
  -preferred-tags $preferred_tags \
  -batch $batch \
  -min-level 3 \
  -max-elem 200 \
  -count 1000
files=`ls $batch`
base=$batch/base
cp -r $orig_base $base
for file in $files; do
  # replace with thit line if you don't want pretty-printing
  # cat $batch/$file > $base/word/document.xml if you
  tidy -xml -i -utf8 < $batch/$file 2> /dev/null > $base/word/document.xml;
  cd $base;
  zip -q -r $batch/$file.docx '[Content_Types].xml' docProps _rels word;
  cd $root;
  rm $batch/$file;
done
rm -r $base

